import { ChannelMessageStorageStateType } from './useChannelData';
import ChatClient, { ChatMessage } from './ChatClient';
export declare const maxSize = 100;
declare class ChannelMessageStorage {
    private channelId;
    private db;
    private messagesCollection;
    private liveUpdate;
    private notMergedMessages;
    private hasMoreEarlier;
    private eventRegistry;
    private loadingEarlier;
    private loadingLater;
    initialMessagesLoaded: boolean;
    constructor(channelId: string);
    setLiveUpdate(liveUpdate: boolean): void;
    upsert(messages: ChatMessage[]): void;
    addLiveMessage(newMessages: ChatMessage[]): void;
    removeMessage(id: string): void;
    softDeleteMessage(id: string): void;
    markAllQueuedMessagesAsRetriable(): void;
    addLaterMessage(laterMessages: ChatMessage[]): void;
    addEarlierMessage(ealierMessages: ChatMessage[]): void;
    sortedMessages(): ChatMessage[];
    latestDate(): string | undefined;
    earliestDate(): string | undefined;
    state(): ChannelMessageStorageStateType;
    loadEarlier(chatClient: ChatClient, unreadMessageCount?: number, lastReadMessageId?: number): Promise<void>;
    loadLater(chatClient: ChatClient): Promise<void>;
    loadAllLater(chatClient: ChatClient): Promise<void>;
    onUpdate(callback: () => void): () => void;
}
export default ChannelMessageStorage;
//# sourceMappingURL=ChannelMessageStorage.d.ts.map