import { ChannelStoragStateType } from './useChannelsData';
import ChatClient, { ArchivedChannel, BlockedUser, ChatChannel, DraftMessage } from './ChatClient';
declare class ChannelsStorage {
    private eventRegistry;
    private channelsCollection;
    private loadingEarlier;
    private hasMoreEarlier;
    private errorMessage?;
    private liveUpdate;
    private loadingLater;
    private initialDataLoaded;
    maxRetryAttemptsReached: boolean;
    private blackList;
    private archivedChannels;
    private draftMessages;
    constructor();
    upsert(channels: ChatChannel[]): void;
    update(channel: ChatChannel): void;
    remove(channelId: string): void;
    addLaterChannels(laterChannels: ChatChannel[]): void;
    sortedChannels(): ChatChannel[];
    earliestDate(): string;
    latestDate(): string;
    loadEarlier(chatClient: ChatClient): Promise<ChatChannel[]>;
    loadLater(chatClient: ChatClient): Promise<ChatChannel[]>;
    loadAllLater(chatClient: ChatClient): Promise<ChatChannel[]>;
    find(channelId: string): ChatChannel | undefined;
    get(channelId: string, chatClient: ChatClient, filter?: {
        skipEmpty?: boolean;
    }): Promise<ChatChannel>;
    getByExternalId(channelExternalId: string, chatClient: ChatClient): Promise<ChatChannel>;
    state(): ChannelStoragStateType;
    onUpdate(callback: (data: any) => void): () => void;
    onDelete(callback: (data: any) => void): () => void;
    setMaxRetryAttemptsReached(flag: boolean): void;
    setBlackList(blackList: BlockedUser[]): void;
    setArchivedChannels(archivedChannels: ArchivedChannel[], targetChannelId?: string): void;
    setDraftMessages(draftMessages: DraftMessage[], targetChannelId?: string): void;
    updateDraftMessage(channelId: string, draft: string | undefined): void;
}
export default ChannelsStorage;
//# sourceMappingURL=ChannelStorage.d.ts.map