declare type ItemConstraint = Record<string, any>;
declare class InMemoryCollection<Item extends ItemConstraint> {
    private items;
    private uniqueKey;
    constructor(uniqueKey: keyof Item);
    compare(item1: Item, item2: Item): boolean;
    hasChanges(collection1: Item[]): boolean;
    upsert(item: Item): Item;
    find(id: string): Item;
    remove(id: string): void;
    findBy(filter: any): Item | undefined;
    findMany(filter: any): Item[];
    sort(key: keyof Item, dir?: 'asc' | 'desc'): Item[];
}
export default InMemoryCollection;
//# sourceMappingURL=InMemoryCollection.d.ts.map