"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.serializeChannels = exports.serializeChannel = exports.serializeChannelMemberships = exports.serializeChannelMembership = exports.serializeMessages = exports.serializeMessage = void 0;
function serializeMessage(message) {
    return __assign(__assign({}, message), { id: String(message.id), senderId: String(message.senderId), localId: message.localId ? String(message.localId) : message.localId, channelExternalId: String(message.channelExternalId), channelId: String(message.channelId), replyToId: String(message.replyToId) });
}
exports.serializeMessage = serializeMessage;
function serializeMessages(messages) {
    return messages.filter(function (message) { return message; }).map(serializeMessage);
}
exports.serializeMessages = serializeMessages;
function serializeChannelMembership(channelMembership) {
    return __assign(__assign({}, channelMembership), { id: String(channelMembership.id), lastReadMessageId: channelMembership.lastReadMessageId
            ? parseInt(String(channelMembership.lastReadMessageId), 10)
            : channelMembership.lastReadMessageId, lastRecievedMessageId: channelMembership.lastRecievedMessageId
            ? parseInt(String(channelMembership.lastRecievedMessageId), 10)
            : channelMembership.lastRecievedMessageId, userId: String(channelMembership.userId), channelId: String(channelMembership.channelId) });
}
exports.serializeChannelMembership = serializeChannelMembership;
function serializeChannelMemberships(channelMemberships) {
    return channelMemberships.map(serializeChannelMembership);
}
exports.serializeChannelMemberships = serializeChannelMemberships;
function serializeChannel(channel) {
    return __assign(__assign({}, channel), { id: String(channel.id), externalId: String(channel.externalId), lastMessage: channel.lastMessage
            ? serializeMessage(channel.lastMessage)
            : null, channelMemberships: serializeChannelMemberships(channel.channelMemberships || []) });
}
exports.serializeChannel = serializeChannel;
function serializeChannels(channels) {
    return channels.map(serializeChannel);
}
exports.serializeChannels = serializeChannels;
//# sourceMappingURL=serializers.js.map