"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useChannelMembershipsData = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("./utils");
var initialState = {
    channelMemberships: [],
    actingUsers: [],
};
var reducer = function (state, action) {
    var channelMembershipsStorage = action.chatService.getChannelMembershipsStorage();
    if (action.type === 'update') {
        return __assign(__assign(__assign({}, state), channelMembershipsStorage.state()), { actingUsers: action.actingUsers || state.actingUsers || [] });
    }
    return state;
};
var useChannelMembershipsData = function (chatService, currentUserId, currentChannelId) {
    var _a;
    var _b = react_1.default.useReducer(reducer, initialState), state = _b[0], dispatch = _b[1];
    var currentUserMembership = react_1.default.useMemo(function () {
        return state.channelMemberships.find(function (channelMembership) {
            return channelMembership.userId === currentUserId &&
                channelMembership.channelId === currentChannelId;
        });
    }, [
        JSON.stringify(state.channelMemberships.find(function (channelMembership) {
            return channelMembership.userId === currentUserId &&
                channelMembership.channelId === currentChannelId;
        })),
        currentUserId,
        currentChannelId,
    ]);
    var otherUserMembership = react_1.default.useMemo(function () {
        return state.channelMemberships.find(function (channelMembership) {
            return currentUserId &&
                channelMembership.userId !== currentUserId &&
                channelMembership.channelId === currentChannelId;
        });
    }, [
        JSON.stringify(state.channelMemberships.find(function (channelMembership) {
            return currentUserId &&
                channelMembership.userId !== currentUserId &&
                channelMembership.channelId === currentChannelId;
        })),
        currentUserId,
        currentChannelId,
    ]);
    react_1.default.useEffect(function () {
        if (chatService) {
            var channelMembershipsStorage = chatService.getChannelMembershipsStorage();
            var removeUpdateListener_1 = channelMembershipsStorage.onUpdate(function () { return __awaiter(void 0, void 0, void 0, function () {
                var currentUser;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, chatService.getCurrentUser()];
                        case 1:
                            currentUser = _a.sent();
                            dispatch({
                                type: 'update',
                                chatService: chatService,
                                chatUser: currentUser,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            return function () {
                removeUpdateListener_1();
            };
        }
    }, [chatService]);
    react_1.default.useEffect(function () {
        function checkTypingUsers(chatService) {
            var _a;
            return __awaiter(this, void 0, void 0, function () {
                var currentUser, channelMembershipsStorage, actingUsers;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, chatService.getCurrentUser()];
                        case 1:
                            currentUser = _b.sent();
                            channelMembershipsStorage = chatService === null || chatService === void 0 ? void 0 : chatService.getChannelMembershipsStorage();
                            actingUsers = (_a = channelMembershipsStorage
                                .sortedChannelMemberships()) === null || _a === void 0 ? void 0 : _a.filter(function (memberShip) {
                                return memberShip.userId !== (currentUser === null || currentUser === void 0 ? void 0 : currentUser.id) &&
                                    memberShip.lastActingAt &&
                                    (0, utils_1.diffInSeconds)(new Date(), new Date(memberShip.lastActingAt)) < 20;
                            }).map(function (memberShip) { return (__assign(__assign({}, memberShip.user), { actingType: memberShip.actingType })); });
                            if (actingUsers && currentUser) {
                                dispatch({
                                    type: 'update',
                                    actingUsers: actingUsers,
                                    chatService: chatService,
                                    chatUser: currentUser,
                                });
                            }
                            return [2 /*return*/];
                    }
                });
            });
        }
        var intervalId = setInterval(function () {
            if (chatService) {
                checkTypingUsers(chatService);
            }
        }, 10 * 1000);
        if (chatService) {
            checkTypingUsers(chatService);
        }
        return function () {
            clearInterval(intervalId);
        };
    }, [
        (_a = state.channelMemberships) === null || _a === void 0 ? void 0 : _a.filter(function (memberShip) {
            return memberShip.lastActingAt &&
                (0, utils_1.diffInSeconds)(new Date(), new Date(memberShip.lastActingAt)) < 20;
        }).length,
        chatService,
    ]);
    return {
        actingUsers: state.actingUsers || [],
        allChannelMemberships: state.channelMemberships,
        currentUserMembership: currentUserMembership,
        otherUserMembership: otherUserMembership,
    };
};
exports.useChannelMembershipsData = useChannelMembershipsData;
//# sourceMappingURL=useChannelMembershipsData.js.map